from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock

class Acorn(ApricotPropertyClass):
    """
    cel property class
    Acorn.
    """

    def __init__(self, oreg):
        ApricotPropertyClass.__init__(self, oreg)

    def SetEntity(self, entity):
        ApricotPropertyClass.SetEntity(self, entity)
        if not entity: return
        self.mesh = celMesh(entity)
        self.movable = self.mesh.Mesh.GetMovable()
        self.sector = None
        self.trigger = None
        self.PropertyClassesHaveChanged()

    def PropertyClassesHaveChanged(self):
        if not self.sector:
            self.sector = self.movable.GetSectors()[0]
        if not self.trigger:
            self.trigger = celTrigger(self.entity)
            self.trigger.follow = True
            #self.trigger.delay = 0
            #self.trigger.jitter = 0
            #self.trigger.EnableMessagesToOthers(False)
            #self.trigger.EnableMessagesToSelf(True)
            self.trigger.EnableTrigger(True)
            self.ReadyToPick()

    def ReadyToPick(self, args = None):
        """
        cel action
        """
        self.sector = self.movable.GetSectors()[0]
        self.trigger.SetupTriggerSphere(self.sector, csVector3(0,0,0), 1.0)
        self.trigger.MonitorEntity("camera")
        self.trigger.MonitorClass("")

    def ReadyToHit(self, args = None):
        """
        cel action
        """
        self.sector = self.movable.GetSectors()[0]
        self.trigger.SetupTriggerSphere(self.sector, csVector3(0,0,0), 2.0)
        self.trigger.MonitorEntity("")
        self.trigger.MonitorClass("enemy")

CEL_IMPLEMENT_FACTORY(Acorn,"apricot.acorn")

