from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock

class ApricotDummy(ApricotPropertyClass):
    """
    cel property class
    Simple property class to use as template (this comment is automatic entry for a class).
    """

    def __init__(self, oreg):
        ApricotPropertyClass.__init__(self, oreg)
        # this is how we add a message callback:
        self.SubscribeMessage("cel.input.up.down", self.StartDoStuff)
        # this is how we remove a message callback:
        self.UnsubscribeMessage("cel.input.up.down")
        #: cel property type:bool rw
        #: This is how we make automatic entry for properties
        self.prop = True
        # Getting Crystal Space interface
        self.interface = oreg.Get(iName)

    # Special hardcoded callback:
    def SetEntity(self, entity):
        ApricotPropertyClass.SetEntity(self, entity)
        if not entity: return
        # this is how we fetch property class:
        self.pclass = celPropertyClassName(entity)
        # this is how we using pc's action:
        self.pclass.Action(bla)
        # this is how we using pc's property:
        self.pclass.bla = True
        # we can also cast function directly:
        self.StartDoStuff(parblock{"par1":"value1", "par2":"value1"})

    # Special hardcoded callback: called in case when property classes have changed (added or removed)
    def PropertyClassesHaveChanged(self):
        pass

    # this would be a message callback, or an action (or both)
    # in case of action below comment is how we making action entry for b2cs menu
    def StartDoStuff(self, args):
        """
        cel action
        @param par1: paramater 1
        @type par1: iCelEntity
        @param par2: parameter 2
        @type par2: str
        """
        # this is how we fetch one of the paramaters
        mypar1 = args["par1"]
        mypar2 = args["par2"]
        # this is how we sending message (self.entity is provided by ApricotPropertyClass)
        self.SendMessage("apricot.message")
        # this is how we reporting stuff on screen
        Reporter.ReportDebug("apricot.class", "Hello world")

CEL_IMPLEMENT_FACTORY(ApricotDummy,"apricot.sample.dummy")

