from pycel import *
import os

icons = None
life_icons = None

BBSPACE = 307200

def LoadTexturesFromDir(dirname):
    texdict = {}
    dirfiles = Vfs.FindFiles(dirname)
    for b in range(dirfiles.Size):
        texpath = dirfiles.Get(b)
        texname = os.path.basename(texpath)
        if texpath.endswith("/"):
           continue
        if not texpath.endswith("png") or texpath.endswith("jpg"):
           continue
        create = True
        if ".svn" not in texpath and ".zip" not in texpath:
            if not Engine.FindTexture(texname):
                tex = Engine.CreateTexture(texname, texpath, None, CS_TEXTURE_2D | CS_TEXTURE_NOMIPMAPS)
                tex.SetKeepImage(True)
                if tex:
                    tex.Register(Graphics3D.GetTextureManager())
                    Engine.CreateMaterial(texname, tex)
                else:
                    create = False
        if create:
            texdict[texname] = Engine.FindTexture(texname)
    return texdict

def LoadTexturesFromList(dirname, filenames):
    texdict = {}
    for filename in filenames:
        texname = filename
        create = True
        if not Engine.FindTexture(filename):
            tex = Engine.CreateTexture(texname, dirname+filename, None, CS_TEXTURE_2D | CS_TEXTURE_NOMIPMAPS)
            if tex:
                tex.SetKeepImage(True)
                tex.Register(Graphics3D.GetTextureManager())
                Engine.CreateMaterial(texname, tex)
            else:
                create = False
        if create:
            texdict[texname] = Engine.FindTexture(texname)
    return texdict

def CreateBillboard(entity, materialname, x = None, y = None, w = None, h = None ):
    global icons,life_icons
    if not icons:
        icons = LoadTexturesFromDir("/tmp/celstart/gui/")
        life_icons = LoadTexturesFromList("/tmp/celstart/gui/hud_life/", ("life_a.png", "life_b.png", "life_c.png", "life_d.png", "life_e.png", "life_f.png", "life_g.png", "life_h.png", "life_i.png", "life_j.png", "life_k.png", "life_l.png", "life_m.png"))
    bb = celBillboard(entity,materialname)
    bb.Billboard.SetTextFont("/tmp/celstart/gui/apricot.ttf", 24)
    bb.name = materialname
    bb.visible = True
    bb.materialname = materialname
    if not x == None:
        bb.x = int(BBSPACE * x)
    if not y == None:
        bb.y = int(BBSPACE * y)
    if not w == None:
        bb.width = int(BBSPACE * w)
    if not h == None:
        bb.height = int(BBSPACE * h)
    return bb
