from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock
import hud
from hud import CreateBillboard, BBSPACE
import random

class HudLife(ApricotPropertyClass,pyPcPropertyListener):
    """
    cel property class
    Life meter on HUD.
    """

    def __init__(self, oreg):
        ApricotPropertyClass.__init__(self, oreg)
        pyPcPropertyListener.__init__(self,oreg)
        self.fg = None

    def SetEntity(self, entity):
        ApricotPropertyClass.SetEntity(self, entity)
        if not entity: return
        celProperties(entity).AddPropertyListener(self)
        self.fg = CreateBillboard(self.entity, hud.life_icons.keys()[0], 0.0, -0.05, 0.2, 0.3)

    def PropertyChanged(self,pcprop,propidx):
        life_icon_keys = hud.life_icons.keys()
        if pcprop.GetPropertyName(propidx) == "life":
            currlife = pcprop["life"]
            if currlife >= len(life_icon_keys):
                return
            self.fg.materialname = life_icon_keys[currlife]

CEL_IMPLEMENT_FACTORY(HudLife,"apricot.hud.life")

