from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock
import hud
from hud import CreateBillboard, BBSPACE

class HudScore(ApricotPropertyClass,pyPcPropertyListener):
    """
    cel property class
    Scores on HUD.
    """

    def __init__(self, oreg):
        ApricotPropertyClass.__init__(self, oreg)
        pyPcPropertyListener.__init__(self, oreg)

    def SetEntity(self, entity):
        ApricotPropertyClass.SetEntity(self, entity)
        if not entity: return
        celProperties(entity).AddPropertyListener(self)
        self.bb = CreateBillboard(self.entity, "hud_score.png", 0.83, 0.015, 0.15, 0.17)
        self.bb.text_offset = csVector2(BBSPACE * 0.037, BBSPACE * 0.047)
        self.bb.text = "0".zfill(3)

    def PropertyChanged(self, pcprop, propidx):
        if pcprop.GetPropertyName(propidx) == "score":
            self.bb.text = str(pcprop[propidx]).zfill(3)

CEL_IMPLEMENT_FACTORY(HudScore,"apricot.hud.score")

