from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock

class Looser(ApricotPropertyClass):
    """
    cel property class
    Entity jumps and disapears after a couple of seconds.
    """

    def __init__(self, oreg):
        ApricotPropertyClass.__init__(self, oreg)
        self.SubscribeMessage("cel.timer.looser.fade", self.Fade)
        #: cel property type:vector3 rw
        #: Velocity during loosing
        self.velocity = csVector3(5.0, 10.0, 0.0)
        self.fadetime = 200
        self.fademinus = 10

    def SetEntity(self, entity):
        ApricotPropertyClass.SetEntity(self, entity)
        if not entity: return
        self.timer = celTimer(entity)
        self.mesh = celMesh(entity)
        self.linmove = celLinearMovement(entity)

    def Boo(self, args):
        """
        cel action
        """
        self.linmove.AddVelocity(self.velocity)
        self.timer.WakeUp(1000, False, "looser.fade")

    def Fade(self, args = None):
        if self.linmove.IsOnGround():
            self.linmove.ClearWorldVelocity()
        else:
            self.timer.WakeUp(100, False, "looser.fade")
            return
        if self.mesh.IsVisible():
            self.mesh.Hide()
        else:
            self.mesh.Show()
        self.fadetime -= self.fademinus
        if self.fadetime <= 0:
            self.fadetime = 0
            print "destroying", self.entity.GetName()
            self.mesh.Hide()
            #PhysicalLayer.RemoveEntity(self.entity)
            return
        self.fademinus += 2
        self.timer.WakeUp(self.fadetime, False, "looser.fade")

CEL_IMPLEMENT_FACTORY(Looser,"apricot.looser")

