from pycel import *
from apricotpc import *
import random as pyrandom

def myrandom():
	return (pyrandom.random()-0.5)*3.0

wait = lambda self,s: PhysicalLayer.CallbackOnce(self,s,CEL_EVENT_PRE)

class Brownian(ApricotPropertyClass):
    """
    cel property class
    Random shaking movement
    """

    def __init__(self,oreg):
        ApricotPropertyClass.__init__(self,oreg)
        #wait(self,500)
        #: cel property type:string
        self._path = ""
        self.cspath = None
    def SetPath(self,val):
        sector = celMesh(self.entity).Mesh.Movable.GetSectors()[0]
        self.cspath = sector.QueryObject().GetChild(iPath,val)
        if not self.cspath:
            Reporter.ReportWarning("apricot.brownian","Path not found "+str(val))
            return
        self._path = val
        self.DoPath()
    def GetPath(self):
        return self._path
    path = property(GetPath,SetPath)
    def DoPath(self):
        pathlen = self.cspath.Length()
        self._endtime = int(self.cspath.GetTime(pathlen-1))
        l = celLinearMovement(self.entity)
        l.SetPath(self.cspath)
        wait(self,self._endtime*1000)
    def SetEntity(self,celEntity):
        ApricotPropertyClass.SetEntity(self,celEntity)
        if not celEntity: return
        self.linmove = celLinearMovement(celEntity)
        self.timer = celTimer(celEntity)
        #self.timer.WakeUp(int(1000.0*myrandom()),False)
        self.timer.WakeUpFrame(CEL_EVENT_PRE)
        self.SetVelocity()

    def SetVelocity(self):
        val = csVector3(myrandom(),myrandom(),myrandom())
        self.linmove.SetVelocity(val)

    def TickOnce (self):
        self.DoPath()
        #self.SetVelocity()

    def TickEveryFrame (self):
        self.SetVelocity()
        #self.timer.WakeUp(int(1000.0*myrandom()),False)

    def pctimer_wakeupframe (self,celentity,args):
        self.SetVelocity()

CEL_IMPLEMENT_FACTORY(Brownian,"apricot.move.brownian")
