from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock

class Chase(ApricotPropertyClass):
    """
    cel property class
    Character that can Chase.
    """

    def __init__(self,oreg):
        ApricotPropertyClass.__init__(self,oreg)
        self.SubscribeMessage("cel.timer.wakeup.frame",self.Chase)
        #: cel property type:bool rw
        #: Enabling chasing
        self._enabled = False
        #: cel property type:string rw
        #: Chased entity name
        self._target = ""

    def SetEntity(self,entity):
        ApricotPropertyClass.SetEntity(self,entity)
        if not entity: return
        self.timer = celTimer(entity)
        self.mesh = celGetMesh(entity)
        self.actormove = celActorMove(entity)
        self.target_ent = None

    def GetTarget(self):
        return self._target

    def SetTarget(self,val):
        self.target_ent = Entities[val]
        self._target = val
        self.CheckProperties()

    def GetEnabled(self):
        return self._enabled

    def SetEnabled(self,val):
        self._enabled = val
        self.CheckProperties()

    def CheckProperties(self):
        if self.enabled == True and self.target_ent != None:
            self.timer.WakeUpFrame(CEL_EVENT_PRE) #TODO: WakeUpFrame(CEL_EVENT_PRE, "chase")
        else:
            self.timer.Clear("frame") #TODO: hmmm... other frame timers will be cleared too ?

    target = property(GetTarget,SetTarget)
    enabled = property(GetEnabled,SetEnabled)

    def Chase(self,args):
        forward = self.mesh.fullposition - celMesh(self.target_ent).fullposition
        forward.y = 0
        self.actormove.MovingForward = 1
        self.mesh.Mesh.GetMovable().GetTransform().LookAt(forward,csVector3(0,1,0))
        self.mesh.Mesh.GetMovable().UpdateMove()

CEL_IMPLEMENT_FACTORY(Chase,"apricot.move.chase")
