import pycel
from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock

class Climb(ApricotPropertyClass):
    """
    cel property class
    Detecting when to switch on/off climb state
    """

    def __init__(self,oreg):
        ApricotPropertyClass.__init__(self,oreg)
        self.SubscribeMessage("cel.timer.move.climb",self.Climb)
        self.climbing = False

    def SetEntity(self,entity):
        ApricotPropertyClass.SetEntity(self,entity)
        if not entity: return
        self.timer = celTimer(entity)
        self.envsensor = pycel.celSensorEnvironment(entity)
        self.timer.WakeUp(250, True, "move.climb")

    def Climb(self,args):
        if self.climbing == False:
            if self.envsensor.target_entity:
                if self.envsensor.target_entity.HasClass(getid("climbable")):
                    self.climbing = True
                    self.entity.QueryMessageChannel().SendMessage("apricot.move.climb.start", self, NoneParBlock)
                    print "climb.start sent"
        else:
            if self.envsensor.target_entity:
                if self.envsensor.target_entity.HasClass(getid("climbable")):
                    return
            self.climbing = False
            self.entity.QueryMessageChannel().SendMessage("apricot.move.climb.end", self, NoneParBlock)
            print "climb.end sent"

CEL_IMPLEMENT_FACTORY(Climb,"apricot.move.climb")

