from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock

class Roll(ApricotPropertyClass):
    """
    cel property class
    ROTF - actor rolling on the floor.
    """

    def __init__(self, oreg):
        ApricotPropertyClass.__init__(self, oreg)
        self.SubscribeMessage("cel.timer.move.roll", self.Tick)
        self.counter = 0

    def SetEntity(self, entity):
        ApricotPropertyClass.SetEntity(self, entity)
        if not entity: return
        self.timer = celTimer(entity)
        self.mesh = celMesh(entity)
        self.prop = celProperties(entity)
        self.linmove = celLinearMovement(entity)

    def Start(self, args):
        self.counter = 0
        self.entity.QueryMessageChannel().SendMessage("apricot.move.roll.start", self, NoneParBlock)
        self.Tick(None)

    def Tick(self, args):
        if self.counter < 3:
            self.timer.WakeUp(1000, False, "move.roll")
            self.linmove.AddVelocity(csVector3(0.0, 4.0, 0.0))
            self.counter = self.counter + 1
        else:
            self.Stop(None)

    def Stop(self, args):
        self.entity.QueryMessageChannel().SendMessage("apricot.move.roll.stop", self, NoneParBlock)

CEL_IMPLEMENT_FACTORY(Roll,"apricot.move.roll")
