from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock
import random

id_enabled = propid("enabled")

class Wander(ApricotPropertyClass):
    """
    cel property class
    Character that can Wander.
    """
    def __init__(self,oreg):
        ApricotPropertyClass.__init__(self,oreg)
        self.SubscribeMessage("cel.timer.move.wander",self.Wander)
        #: cel property type:bool rw
        #: Enabling wandering
        self._enabled = False

    def SetEnabled(self,val):
        if val == True:
            self.Wander(None)
            self.timer.WakeUp(15000, True, "move.wander")
        else:
            self.timer.Clear("move.wander")

    def GetEnabled(self):
        return self._enabled

    enabled = property(GetEnabled,SetEnabled)

    def SetEntity(self,entity):
        ApricotPropertyClass.SetEntity(self,entity)
        if not entity: return
        self.actormove = celActorMove(entity)
        self.timer = celTimer(entity)

    def Wander(self,args):
        advance = random.random()
        is_advancing = advance<0.5
        value = random.random()
        if value<0.3 and is_advancing:
            self.actormove.RotatingLeft = 1
            self.actormove.RotatingRight = 0
            self.timer.Clear("move.wander")
            self.timer.WakeUp(500, True, "move.wander")
        elif value<0.8 and is_advancing:
            self.actormove.RotatingLeft = 0
            self.actormove.RotatingRight = 1
            self.timer.Clear("move.wander")
            self.timer.WakeUp(500, True, "move.wander")
        else:
            self.actormove.RotatingLeft = 0
            self.actormove.RotatingRight = 0
        if is_advancing:
            if not self.actormove.MovingForward:
                self.actormove.MovingForward = 1
                self.actormove.MovingBackward = 0
        else:
            if self.actormove.MovingForward:
                self.actormove.MovingForward = 0
                self.actormove.MovingBackward = 0

CEL_IMPLEMENT_FACTORY(Wander,"apricot.move.wander")
