from pycel import *
from apricotpc import ApricotPropertyClass

starttick = lambda self: PhysicalLayer.CallbackEveryFrame(self,CEL_EVENT_PRE)

class PhysicsBodySync(ApricotPropertyClass):
    """
    cel property class
    Sync a (static) collider with mesh position every frame.
    """
    def SetEntity(self,entity):
        ApricotPropertyClass.SetEntity(self,entity)
        if not entity: return
        self.mov = celGetMesh(entity).Mesh.Movable
        starttick(self)
    def TickEveryFrame(self):
        physobj = celGetMechanicsObject(self.entity)
        if not physobj:
            print "no body"
        physobj.Body.Enable()
        physobj.Body.SetPosition(self.mov.Position)
        physobj.Body.Update()
        

CEL_IMPLEMENT_FACTORY(PhysicsBodySync,"apricot.physics.syncbody")

