from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock

# TODO: use pcdamage instead of hardcoded stuff

class SensorFall(ApricotPropertyClass):
    """
    cel property class
    Character hurts when falling from a high.
    """

    def __init__(self,oreg):
        ApricotPropertyClass.__init__(self,oreg)
        self.SubscribeMessage("cel.timer.wakeup.frame",self.Detect)
        #: cel property type:float
        self.limitvelocity = 10

    def SetEntity(self,entity):
        ApricotPropertyClass.SetEntity(self,entity)
        if not entity: return
        self.mov = celGetMesh(entity).Mesh.GetMovable()
        self.linmove = celLinearMovement(entity)
        self.timer = celTimer(entity)
        self.timer.WakeUpFrame(CEL_EVENT_PRE)
        self.prevspeed = self.linmove.GetVelocity().y
        self.prop = celProperties(entity)

    def Detect(self,args):
        # test y speed
        currspeed = self.linmove.GetVelocity().y
        if currspeed - self.prevspeed > self.limitvelocity:
            self.entity.QueryMessageChannel().SendMessage("apricot.playerhit", self, NoneParBlock)
            self.prop["lives"]-=1
            print self.prop["lives"]
            print "ouch!",currspeed - self.prevspeed
        self.prevspeed = currspeed

CEL_IMPLEMENT_FACTORY(SensorFall,"apricot.sensor.fall")
