from pycel import *
from apricotpc import ApricotPropertyClass, NoneParBlock
import random as pyrandom

class SoundRandom(ApricotPropertyClass):
    """
    cel property class
    Playing sounds in random time (given range).
    """

    def __init__(self, oreg):
        ApricotPropertyClass.__init__(self, oreg)
        self.SubscribeMessage("cel.timer.sound.random.play", self.PlayRandomly)
        #: cel property type:int rw
        #: Minimal delay
        self.mindelay = 5000
        #: cel property type:int rw
        #: Maximal delay
        self.maxdelay = 10000

    def SetEntity(self, entity):
        ApricotPropertyClass.SetEntity(self, entity)
        if not entity: return
        self.timer = celTimer(entity)
        self.sound = celSoundSource(entity)
        pyrandom.seed()
        self.timer.WakeUp(pyrandom.randint(self.mindelay, self.maxdelay), False, "sound.random.play")

    def PlayRandomly(self, args):
        self.sound.Play()
        self.timer.WakeUp(pyrandom.randint(self.mindelay, self.maxdelay), False, "sound.random.play")

CEL_IMPLEMENT_FACTORY(SoundRandom,"apricot.sound.random")
